/************************************************************************************
*************************************************************************************
*http.h: 
*Declarations to functions in http.c
*
*Copyright (c) 2011 by Manu Dhundi. All rights reserved.
*
*************************************************************************************
************************************************************************************/

#ifdef __cplusplus
	extern "C" {
#endif

typedef enum {
	eHTTP_PUT = 1,
	eHTTP_POST
}sendMethod;

/*****************************************************************
* httpHeaderInit()
* Initialize the HTTP header with Method and Url
*
*
*****************************************************************/
char* httpHeaderInit(char* pBuf, char* pHttpMethod, char* pUrl);

/*****************************************************************
* httpAddField()
* Adds the field and value to already initialized header
*
*
*****************************************************************/
char* httpAddField(char* pBuf, char* pHttpFieldName, char* pHttpFieldValue);


/*****************************************************************
* httpHeaderEnd()
* Adds the field and value to already initialized header
*
*
*****************************************************************/
char* httpHeaderEnd(char* pBuf);

/*****************************************************************
* httpParseStatusCode()
* Parses pBuf for httpStatusCode. The status code sent to the calling function
* through pStatusCode
*
*returns 0 on success and -1 on failure.
*****************************************************************/
int httpParseStatusCode(char* pBuf, int* pStatusCode);


#ifdef __cplusplus
    }
#endif /*__cplusplus*/
