/*
 * Code : SECE_server.java
 * Author : Kunal Mudgal
 * Description : Servlet to parse json data received from client. If ServiceAddFlag == 1 and device does not 
 * 				 exist in list, add device. If ServiceAddFlag == 0, delete the device from list
*/
package org.sece;

import java.io.*;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import javax.ws.rs.Consumes;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.xml.parsers.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.json.simple.*;
import org.json.simple.parser.ContainerFactory;
import org.json.simple.parser.JSONParser;
//import org.json.simple.parser;
//import org.json.simple.parser.JSONParser;
//import org.json.simple.parser.ParseException;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Attr;
import org.xml.sax.SAXException;

import com.sun.faces.util.HtmlUtils;

/**
 * Servlet implementation class SECE_server
 */
@WebServlet(name = "SECE_server", urlPatterns = { "/sece_server" })
public class SECE_server extends HttpServlet {
	private static final long serialVersionUID = 1L;

	static String query = "";

	/**
	 * @see HttpServlet#HttpServlet()
	 */
	public SECE_server() {
		super();
		// TODO Auto-generated constructor stub
	}

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse
	 *      response)
	 */
	protected void doGet(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {

		response.setContentType("text/html");

		// Temporary file used to process json data in request
		File jsonfile = new File("C:\\Users\\Kunal\\AIS\\SECE\\data12345.json");

		// File for logging client information
		File securityfile = new File(
				"C:\\Users\\Kunal\\AIS\\SECE\\securitydata.txt");

		FileWriter fwsec = new FileWriter(securityfile, true);

		fwsec.write("\nRemote Address : " + request.getRemoteAddr()); // Security
		fwsec.write("\nRemote Port : " + request.getRemotePort()); // data
		fwsec.write("\nContent Length : " + request.getContentLength()); // from
																			// client
		fwsec.write("\n-------------------------------------------");
		fwsec.close();

		FileWriter fw = new FileWriter(jsonfile);

		PrintWriter out = response.getWriter();
		BufferedReader br = request.getReader();

		String thisLine;

		// if (jsonfile.length() != 0) {

		while ((thisLine = br.readLine()) != null) { // while loop begins
														// here
			fw.write(thisLine);
			System.out.println("DEBUG : DATA-------->" + thisLine);
		}

		fw.close();
		// }

		//JSON Parser
		JSONParser parser = new JSONParser();
		ContainerFactory containerFactory = new ContainerFactory() {

			public List creatArrayContainer() {
				return new LinkedList();
			}

			public Map createObjectContainer() {
				return new LinkedHashMap();
			}

		};

		List<String> ResultArray = new ArrayList<String>();
		try {
			//Setup an SQL Database Connection
			Connection connect = null;
			PreparedStatement preparedStatement = null;
			Class.forName("com.mysql.jdbc.Driver");
			connect = DriverManager
					.getConnection("jdbc:mysql://localhost/SECE?"
							+ "user=root&password=password");
			if (jsonfile.length() != 0) {

				Map json = (Map) parser.parse(new FileReader(jsonfile),
						containerFactory);
				Iterator iter = json.entrySet().iterator();

				while (iter.hasNext()) {
					Map.Entry entry = (Map.Entry) iter.next();
					ResultArray.add(entry.getValue().toString());
				}

				Boolean deviceDelete = false;

				System.out.println("DEBUG : VAlue of  ResultArray.get(5) :"
						+ ResultArray.get(5));

				//If ServiceAddFlag == 0, mark device for deletion
				if (ResultArray.get(5).equalsIgnoreCase("0")) {
					deviceDelete = true;
				}
				query = "select ServiceName from SECE.devices"
						+ " where devices.ServiceName = ? "
						+ " and devices.ServiceState = '1'";

				PreparedStatement ps = connect.prepareStatement(query);
				ps.setString(1, ResultArray.get(0));
				ResultSet ifexists = ps.executeQuery();

				System.out.println("DEBUG : VAlue of  deviceDelete :"
						+ deviceDelete);

				Boolean booexists = ifexists.next();

				System.out.println("DEBUG : VAlue of  ifexists.next() :"
						+ booexists);

				//If Device does not exist in table or isn't for Deletion
				if (!deviceDelete && !booexists) {
					preparedStatement = connect
							.prepareStatement("INSERT  SECE.devices values ("
									+ "'" + ResultArray.get(0) + "'," + "'"
									+ ResultArray.get(1) + "'," + "'"
									+ ResultArray.get(2) + "'," + "'"
									+ ResultArray.get(3) + "'," + "'"
									+ ResultArray.get(4) + "'," + "'"
									+ ResultArray.get(5) + "'" + ");");
					Integer resultset = preparedStatement.executeUpdate();

					System.out
							.println("DEBUG : Insertng into Database. No of rows : "
									+ resultset);
				} 
				else if (booexists && deviceDelete) {
					preparedStatement = connect
							.prepareStatement("DELETE FROM SECE.devices WHERE  devices.ServiceName = '"
									+ ResultArray.get(0) + "'");
					Integer resultset = preparedStatement.executeUpdate();
					System.out
							.println("DEBUG : Deleting from Database. No of rows : "
									+ resultset);
				} 
				//Do nothing
				else {
					System.out.println("DEBUG : Duplicate entry. Ignoring.");
				}

			}

			//List devices on servlet. Mainly for debugging
			query = "select ServiceName, ServiceType,ServiceIP,HostName, PORT, ServiceState from SECE.devices"
					+ " where devices.ServiceState = ? ";

			PreparedStatement ps = connect.prepareStatement(query);
			// out.println("Result 1");
			ps.setString(1, "1");
			// out.println("Result 2");
			ResultSet resultSet = ps.executeQuery();

			// System.out.println("DEBUG : "+resultSet);
			out.println("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 "
					+ "Transitional//EN\">\n"
					+ "<HTML>\n"
					+ "<HEAD><TITLE>Available Devices-SECE</TITLE></HEAD>\n"
					+ "<BODY>\n"
					+ "<table border=\"1\" CELLPADDING=\"2\" CELLSPACING=\"2\" WIDTH=\"100%\">\n"
					+ "<tr>\n" + "<td WIDTH=\"40%\">ServiceName</td>\n"
					+ "<td WIDTH=\"20%\">ServiceIP</td>\n"
					+ "<td WIDTH=\"20%\">HostName</td>\n"
					+ "<td WIDTH=\"10%\">PORT</td>\n"
					+ "<td WIDTH=\"10%\">ServiceState</td>\n" + "</tr>\n"
					+ "</BODY></HTML>");
			// out.println(resultSet.toString());

			// System.out.println("Service State"+resultSet.getString("ServiceState"));

			while (resultSet.next()) {
				// out.println("Result :" + resultSet.getString("ServiceName"));
				String servicestate;
				if (resultSet.getString("ServiceState") == "1") {
					servicestate = "ADD";
				} else {
					servicestate = "DROP";
				}
				// PrintWriter out;
				out.println("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 "
						+ "Transitional//EN\">\n"
						+ "<HTML>\n"
						+ "<HEAD><TITLE>Available Devices-SECE</TITLE></HEAD>\n"
						+ "<BODY>\n"
						+ "<table border=\"1\" CELLPADDING=\"2\" CELLSPACING=\"2\" WIDTH=\"100%\">\n"
						+ "<tr>\n" + "<td WIDTH=\"40%\">"
						+ resultSet.getString("ServiceName") + "</td>\n"
						+ "<td WIDTH=\"20%\">"
						+ resultSet.getString("ServiceIP") + "</td>\n"
						+ "<td WIDTH=\"20%\">"
						+ resultSet.getString("HostName") + "</td>\n"
						+ "<td WIDTH=\"10%\">" + resultSet.getString("PORT")
						+ "</td>\n" + "<td WIDTH=\"10%\">" + servicestate
						+ "</td>\n" + "</tr>\n" + "</BODY></HTML>");

			}
		} catch (org.json.simple.parser.ParseException e) {
			out.println(e);
		} catch (ClassNotFoundException e) {
			out.println(e);
		} catch (SQLException e) {
			out.println(e);
		}

	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse
	 *      response)
	 */
	protected void doPost(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {

		/*
		 * request.getAttribute("attr");
		 * 
		 * for(int j=0;j<device.size();j++) { System.out.println("Second time");
		 * out.println(device.get(j)); }
		 */
		doGet(request, response);
	}

}
